package tech.nevets.modbot;

import net.dv8tion.jda.api.JDA;
import net.dv8tion.jda.api.JDABuilder;
import net.dv8tion.jda.api.hooks.ListenerAdapter;
import net.dv8tion.jda.api.utils.cache.CacheFlag;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import tech.nevets.modbot.api.BotModule;
import tech.nevets.modbot.api.Config;
import tech.nevets.modbot.util.commands.CommandListener;

import javax.security.auth.login.LoginException;
import java.util.*;

public class CoreBot {
    public static JDA jda;
    public static final Config CORE_CONFIG = new Config("core");
    public static final List<ListenerAdapter> PLUGIN_LISTENERS = new ArrayList<>();
    private static List<BotModule> modules;
    private static final Logger LOGGER = LoggerFactory.getLogger(CoreBot.class);

    public static void main(String[] args) {
        CORE_CONFIG.addDefaults(getDefaults());
        CORE_CONFIG.loadConfig();
        modules = ModuleLoader.loadModules();

        JDABuilder builder = JDABuilder.createDefault(CORE_CONFIG.getConfig().getString("bot.token"))
                .enableCache(CacheFlag.VOICE_STATE)
                .addEventListeners(new CommandListener());

        for (ListenerAdapter listener : PLUGIN_LISTENERS) {
            builder.addEventListeners(listener);
        }

        try {
            jda = builder.build();
        } catch (LoginException e) {
            e.printStackTrace();
        }

        //CommandManager.registerSlashCommands();
        for (BotModule module : modules) {
            module.onEnable(jda);
        }

    }

    public static void addListener(ListenerAdapter listener) {
        PLUGIN_LISTENERS.add(listener);
    }

    private static Map<String, Object> getDefaults() {
        Map<String, Object> defaults = new HashMap<>();
        defaults.put("bot.token", "xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx");
        defaults.put("bot.prefix", "!");

        return defaults;
    }
}
